## picolisp 3.0.7.7

=== src64/Makefile ===
# 16jun11abu
# (c) Software Lab. Alexander Burger

.SILENT:

bin = ../bin
lib = ../lib

ifeq ($(shell uname), Linux)
	OS = Linux
	SYS = linux
	ifeq ($(shell uname -m), x86_64)
		ARCH = x86-64
		AS = as
	else
	ifeq ($(shell uname -m), ppc64)
		ARCH = ppc64
		AS = as -mppc64 -a64
	endif
	endif
	LD-MAIN = gcc -m64 -rdynamic -lc -lm -ldl
	LD-SHARED = gcc -m64 -shared -export-dynamic
	STRIP = strip
else
ifeq ($(shell uname), SunOS)
	OS = SunOS
	SYS = sunOs
	ARCH = x86-64
	AS = gas --64
	LD-MAIN = gcc -m64 -lc -lm -ldl -lsocket -lnsl
	LD-SHARED = gcc -m64 -shared
	STRIP = strip
endif
endif

baseFiles = version.l glob.l main.l \
	gc.l apply.l flow.l sym.l subr.l big.l io.l db.l net.l err.l

picolisp: $(bin)/picolisp $(lib)/ext $(lib)/ht

all: picolisp

$(bin)/picolisp: $(ARCH).$(SYS).base.o
	mkdir -p $(bin) $(lib)
	$(LD-MAIN) -o $(bin)/picolisp $(ARCH).$(SYS).base.o
	$(STRIP) $(bin)/picolisp

$(lib)/ext: $(ARCH).$(SYS).ext.o
	$(LD-SHARED) -o $(lib)/ext $(ARCH).$(SYS).ext.o
	$(STRIP) $(lib)/ext

$(lib)/ht: $(ARCH).$(SYS).ht.o
	$(LD-SHARED) -o $(lib)/ht $(ARCH).$(SYS).ht.o
	$(STRIP) $(lib)/ht

.s.o:
	$(AS) -o $*.o $*.s


# Explicit builds for cross-assembly
x86-64.linux.base.s: lib/asm.l arch/x86-64.l $(baseFiles) sys/x86-64.linux.code.l
	./mkAsm x86-64 linux Linux base $(lib)/tags $(baseFiles) sys/x86-64.linux.code.l

x86-64.linux.ext.s: lib/asm.l arch/x86-64.l ext.l
	./mkAsm x86-64 linux Linux ext "" -fpic ext.l

x86-64.linux.ht.s: lib/asm.l arch/x86-64.l ht.l
	./mkAsm x86-64 linux Linux ht "" -fpic ht.l


ppc64.linux.base.s: lib/asm.l arch/ppc64.l $(baseFiles) sys/ppc64.linux.code.l
	./mkAsm ppc64 linux Linux base $(lib)/tags $(baseFiles) sys/ppc64.linux.code.l -'prSym "ppc64.symtab"'

ppc64.linux.ext.s: lib/asm.l arch/ppc64.l ext.l ppc64.linux.base.s
	./mkAsm ppc64 linux Linux ext "" -fpic -'rdSym "ppc64.symtab"' ext.l

ppc64.linux.ht.s: lib/asm.l arch/ppc64.l ht.l ppc64.linux.base.s
	./mkAsm ppc64 linux Linux ht "" -fpic -'rdSym "ppc64.symtab"' ht.l


x86-64.sunOs.base.s: lib/asm.l arch/x86-64.l $(baseFiles) sys/x86-64.sunOs.code.l
	./mkAsm x86-64 sunOs SunOS base $(lib)/tags $(baseFiles) sys/x86-64.sunOs.code.l

x86-64.sunOs.ext.s: lib/asm.l arch/x86-64.l ext.l
	./mkAsm x86-64 sunOs SunOS ext "" -fpic ext.l

x86-64.sunOs.ht.s: lib/asm.l arch/x86-64.l ht.l
	./mkAsm x86-64 sunOs SunOS ht "" -fpic ht.l


# Clean up
clean:
	rm -f *.s *.o

# vi:noet:ts=4:sw=4

=== debian/changelog ===
picolisp (3.0.7.7-2) unstable; urgency=low

  * Sync to upstream tip.
    - Fix FTBFS with -Wl,--as-needed flag. (LP: #831180)

 -- Kan-Ru Chen <koster@debian.org>  Wed, 07 Sep 2011 06:08:28 +0800

picolisp (3.0.7.7-1) unstable; urgency=low

  * New upstream release.
  * Sync to upstream tip.

 -- Kan-Ru Chen <koster@debian.org>  Sun, 04 Sep 2011 14:51:15 +0800

picolisp (3.0.7.6-2) unstable; urgency=low

  * Apply patches from upstream.
    - Fix 64-bit random seed initialization.

 -- Kan-Ru Chen <koster@debian.org>  Fri, 19 Aug 2011 18:40:16 +0800

picolisp (3.0.7.6-1) unstable; urgency=low

  * New upstream release.
    - Fix a bug in reading from a pipe from stdin.

 -- Kan-Ru Chen <koster@debian.org>  Fri, 19 Aug 2011 10:40:41 +0800

picolisp (3.0.7.4-1) unstable; urgency=low

  * New upstream release.
  * Sync to upstream tip.

 -- Kan-Ru Chen <koster@debian.org>  Sun, 24 Jul 2011 09:27:15 +0200

picolisp (3.0.7.2-2) unstable; urgency=low

  * Sync to upstream tip.
  * Drop two unused patches.

 -- Kan-Ru Chen <koster@debian.org>  Mon, 11 Jul 2011 17:48:35 +0800

picolisp (3.0.7.2-1) unstable; urgency=low

  * New upstream release.
  * Fix *OS should be "Linux" on Debian system.

 -- Kan-Ru Chen <koster@debian.org>  Sun, 10 Jul 2011 16:29:34 +0800

picolisp (3.0.7.1-1) unstable; urgency=low

  * New upstream release.

 -- Kan-Ru Chen <koster@debian.org>  Fri, 08 Jul 2011 01:32:42 +0800

picolisp (3.0.6.14-1) unstable; urgency=low

  * New upstream release.
  * Install plmod to usr/lib/picolisp/bin (Closes: #627451)

 -- Kan-Ru Chen <koster@debian.org>  Mon, 30 May 2011 22:33:54 +0800

picolisp (3.0.6.11-1) unstable; urgency=low

  * New upstream release.
  * Don't compress .l files.

 -- Kan-Ru Chen <koster@debian.org>  Fri, 13 May 2011 15:55:13 +0800

picolisp (3.0.6.10-2) unstable; urgency=low

  * Add missing build dependency.

 -- Kan-Ru Chen <koster@debian.org>  Thu, 12 May 2011 04:53:33 +0800

picolisp (3.0.6.10-1) unstable; urgency=low

  * New upstream release.
  * Import new picolisp.el from upstream.
  * Install additional supporting binaries to /usr/lib/picolisp/bin.
  * Stop shipping "simul/" and "rcsim/".
  * Add lintian overrides for OpenSSL linkage.

 -- Kan-Ru Chen <koster@debian.org>  Wed, 11 May 2011 15:44:30 +0800

picolisp (3.0.6.9-1) unstable; urgency=low

  * New upstream release.
  * With consensus of upstream, bundled applications now are installed to
    /usr/share/picolisp.
  * Fix typo in package description, thanks to Vincent Blut.
    (Closes: #624454)
  * Add any-armhf to arch list. (Closes: #623351)

 -- Kan-Ru Chen <koster@debian.org>  Mon, 09 May 2011 17:29:45 +0800

picolisp (3.0.6.5-2) unstable; urgency=low

  * Move bundled applications to /usr/lib/picolisp.
  * Fix shebangs for psh, replica and watchdog.

 -- Kan-Ru Chen <koster@debian.org>  Thu, 28 Apr 2011 14:09:35 +0800

picolisp (3.0.6.5-1) unstable; urgency=low

  * New upstream release.
  * Install img, loc, doc, src and src64 as required by upstream.
  * Fix mips, mipsel and armhf build. (Closes: #623351)
  * Bump Standards-Version to 3.9.2, no changes needed.

 -- Kan-Ru Chen <koster@debian.org>  Sun, 24 Apr 2011 16:20:39 +0800

picolisp (3.0.6.1-1) unstable; urgency=low

  * New upstream release.
  * Fix FTBFS on Armel and S/390.

 -- Kan-Ru Chen <koster@debian.org>  Wed, 13 Apr 2011 22:03:26 +0800

picolisp (3.0.5.23-2) unstable; urgency=low

  * Remove lib/z3d which only builds on 32-bit architecture and isn't used
    by any libraries.

 -- Kan-Ru Chen <koster@debian.org>  Sun, 13 Mar 2011 02:09:41 +0800

picolisp (3.0.5.23-1) unstable; urgency=low

  * Initial release (Closes: #533011)

 -- Kan-Ru Chen <koster@debian.org>  Fri, 11 Mar 2011 07:44:02 +0800

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_HOST_ARCH_OS  := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

override_dh_auto_build:

	chmod -x app/loc/no
	chmod +x bin/plmod

	make -C src OS=Linux CPU=$(DEB_HOST_ARCH_CPU) picolisp tools gate

ifeq (amd64,$(DEB_HOST_ARCH_CPU))
	make -C src64 OS=Linux
endif

override_dh_auto_install:

	dh_install -X.o src   usr/lib/picolisp
	dh_install -X.o src64 usr/lib/picolisp

override_dh_auto_clean:

	make -C src clean
	make -C src64 clean
	-rm bin/ssl bin/httpGate bin/lat1 bin/utf2 bin/z3dClient bin/balance

override_dh_compress:

	dh_compress -X.l

%:
	dh $@ 

VER?=3.0.7.1
get-orig-source:
	rm -rf picolisp-$(VER).orig
	hg clone https://picolisp.googlecode.com/hg/ picolisp-$(VER).orig
	cd picolisp-$(VER).orig && hg up -r v$(VER)
	rm -r picolisp-$(VER).orig/.hg picolisp-$(VER).orig/.hgtags
	GZIP=--best tar -cz --owner root --group root --mode a+rX \
			-f picolisp_$(VER).orig.tar.gz \
			picolisp-$(VER).orig
	rm -r picolisp-$(VER).orig

## picolisp 3.0.8.7

=== debian/changelog ===
picolisp (3.0.8.7-1) unstable; urgency=low

  * New upstream release.

 -- Kan-Ru Chen <koster@debian.org>  Sun, 13 Nov 2011 17:15:44 +0800

picolisp (3.0.8.5-2) unstable; urgency=low

  * Sync to upstream tip with important fixes.

 -- Kan-Ru Chen <koster@debian.org>  Fri, 28 Oct 2011 00:07:36 +0800

picolisp (3.0.8.5-1) unstable; urgency=low

  * New upstream release.
    - Force linkage with libm, fix 64-bit build in Ubuntu. (LP: #874841)
  * Sync to upstream tip with IPv6 support.

 -- Kan-Ru Chen <koster@debian.org>  Thu, 27 Oct 2011 11:29:38 +0800

picolisp (3.0.8.1-2) unstable; urgency=low

  * Add back accidentally removed file to non-amd64 arch.

 -- Kan-Ru Chen <koster@debian.org>  Sun, 02 Oct 2011 18:47:24 +0800

picolisp (3.0.8.1-1) unstable; urgency=low

  * New upstream release.

 -- Kan-Ru Chen <koster@debian.org>  Sat, 01 Oct 2011 22:42:46 +0800

## picolisp 3.0.8.10

=== src/Makefile ===
# 07mar11abu
# 27feb08rdo
# (c) Software Lab. Alexander Burger

bin = ../bin
lib = ../lib

picoFiles = main.c gc.c apply.c flow.c sym.c subr.c big.c io.c net.c tab.c

CFLAGS := -c -O2 -m32 -pipe \
	-falign-functions -fomit-frame-pointer -fno-strict-aliasing \
	-W -Wimplicit -Wreturn-type -Wunused -Wformat \
	-Wuninitialized -Wstrict-prototypes \
	-D_GNU_SOURCE  -D_FILE_OFFSET_BITS=64


ifeq ($(shell uname), Linux)
	OS = Linux
	PICOLISP-FLAGS = -m32 -rdynamic
	LIB-FLAGS = -lc -lm -ldl
	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
	STRIP = strip
else
ifeq ($(shell uname), OpenBSD)
	OS = OpenBSD
	PICOLISP-FLAGS = -m32 -rdynamic -Wl,-E
	LIB-FLAGS = -lc -lm
	DYNAMIC-LIB-FLAGS = -Wl,-E -Wl,-shared
	STRIP = strip
else
ifeq ($(shell uname), FreeBSD)
	OS = FreeBSD
	PICOLISP-FLAGS = -m32 -rdynamic
	LIB-FLAGS = -lc -lm
	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
	STRIP = strip
else
ifeq ($(shell uname), NetBSD)
	OS = NetBSD
	PICOLISP-FLAGS = -m32 -rdynamic
	LIB-FLAGS = -lc -lm
	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
	STRIP = strip
else
ifeq ($(shell uname), Darwin)
	OS = Darwin
	PICOLISP-FLAGS = -m32
	LIB-FLAGS = -lc -lm -ldl
	DYNAMIC-LIB-FLAGS = -m32 -dynamiclib -undefined dynamic_lookup
	STRIP = :
else
ifeq ($(shell uname -o), Cygwin)
	OS = Cygwin
	DYNAMIC-LIB-FLAGS = -shared
	PICOLISP-FLAGS =
	DLL-DEFS = $(bin)/picolisp.dll
	STRIP = strip
	exe = .exe
	dll = .dll
endif
endif
endif
endif
endif
endif


picolisp: $(bin)/picolisp $(lib)/ext$(dll) $(lib)/ht$(dll) $(lib)/z3d$(dll)
tools: $(bin)/lat1 $(bin)/utf2 $(bin)/balance
gate: $(bin)/ssl $(bin)/httpGate
x11: $(bin)/z3dClient

all: picolisp tools gate x11

.c.o:
	gcc $(CFLAGS) -D_OS='"$(OS)"' $*.c


$(picoFiles:.c=.o) ext.o ht.o z3d.o: pico.h
main.o: vers.h


ifeq ($(OS), Cygwin)

$(bin)/picolisp$(dll): $(picoFiles:.c=.o)
	gcc -o $(bin)/picolisp$(dll) $(DYNAMIC-LIB-FLAGS) $(picoFiles:.c=.o)
	$(STRIP) $(bin)/picolisp$(dll)

$(bin)/picolisp: $(picoFiles:.c=.o) $(bin)/picolisp$(dll) start.o
	mkdir -p $(bin) $(lib)
	gcc -o $(bin)/picolisp$(exe) $(PICOLISP-FLAGS) start.o -L$(bin) -l$(bin)/picolisp
	$(STRIP) $(bin)/picolisp$(exe)

else

$(bin)/picolisp: $(picoFiles:.c=.o)
	mkdir -p $(bin) $(lib)
	gcc -o $(bin)/picolisp$(exe) $(PICOLISP-FLAGS) $(picoFiles:.c=.o) $(LIB-FLAGS)
	$(STRIP) $(bin)/picolisp$(exe)

endif


$(lib)/ext$(dll): ext.o
	gcc -o $(lib)/ext$(dll) $(DYNAMIC-LIB-FLAGS) ext.o $(DLL-DEFS)
	$(STRIP) $(lib)/ext$(dll)

$(lib)/ht$(dll): ht.o
	gcc -o $(lib)/ht$(dll) $(DYNAMIC-LIB-FLAGS) ht.o $(DLL-DEFS)
	$(STRIP) $(lib)/ht$(dll)

$(lib)/z3d$(dll): z3d.o
	gcc -o $(lib)/z3d$(dll)  $(DYNAMIC-LIB-FLAGS) z3d.o $(DLL-DEFS)
	$(STRIP) $(lib)/z3d$(dll)


$(bin)/lat1: lat1.c
	gcc -o $(bin)/lat1$(exe) lat1.c
	$(STRIP) $(bin)/lat1$(exe)

$(bin)/utf2: utf2.c
	gcc -o $(bin)/utf2$(exe) utf2.c
	$(STRIP) $(bin)/utf2$(exe)

$(bin)/balance: balance.c
	gcc -o $(bin)/balance$(exe) balance.c
	$(STRIP) $(bin)/balance$(exe)

$(bin)/ssl: ssl.c
	gcc -o $(bin)/ssl$(exe) ssl.c -lssl -lcrypto
	$(STRIP) $(bin)/ssl$(exe)

$(bin)/httpGate: httpGate.c
	gcc -o $(bin)/httpGate$(exe) httpGate.c -lssl -lcrypto
	$(STRIP) $(bin)/httpGate$(exe)

$(bin)/z3dClient: z3dClient.c
	gcc -o $(bin)/z3dClient$(exe) z3dClient.c  -L/usr/X11R6/lib -lXext -lX11
	$(STRIP) $(bin)/z3dClient$(exe)


# Clean up
clean:
	rm -f *.o

# vi:noet:ts=4:sw=4

=== debian/changelog ===
picolisp (3.0.8.10-1) unstable; urgency=low

  * New upstream release.

 -- Kan-Ru Chen <koster@debian.org>  Sat, 17 Dec 2011 10:42:10 +0800

=== debian/control ===
Source: picolisp
Section: lisp
Priority: optional
Maintainer: Kan-Ru Chen <koster@debian.org>
Build-Depends: debhelper (>= 7.0.50~), libssl-dev, gcc-multilib [amd64]
Standards-Version: 3.9.2
Homepage: http://picolisp.com/
Vcs-Git: git://git.debian.org/collab-maint/picolisp.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/picolisp.git;a=summary

# Only supports amd64 on linux and solaris
Package: picolisp
Architecture: kopensolaris-amd64 solaris-amd64 amd64 any-i386 any-armel any-armeb any-arm any-avr32 any-hppa any-m32r any-m68k any-mips any-mipsel any-powerpc any-s390 any-sh3 any-sh3eb any-sh4 any-sh4eb any-sparc any-armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lisp interpreter and application server framework
 Pico Lisp can be viewed from two different aspects: As a general
 purpose programming language, and a dedicated application server
 framework.
 .
 As a programming language, Pico Lisp provides a 1-to-1 mapping of a
 clean and powerful Lisp derivate, to a simple and efficient virtual
 machine. It supports persistent objects as a first class data type,
 resulting in a database system of Entity/Relation classes and a
 Prolog-like query language tightly integrated into the system.
 .
 As an application server framework, Pico Lisp provides for database
 management (including multi-user synchronization, DB garbage collection
 journalling and replication), web interface integrated (and generated
 from) the application data model, and an application server.

=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,7 @@
 	make -C src OS=Linux CPU=$(DEB_HOST_ARCH_CPU) picolisp tools gate
 
 ifeq (amd64,$(DEB_HOST_ARCH_CPU))
+	mv src64/tags src64/tags.orig
 	make -C src64 OS=Linux
 endif
 
@@ -28,6 +29,7 @@
 	make -C src clean
 	make -C src64 clean
 	-rm bin/ssl bin/httpGate bin/lat1 bin/utf2 bin/z3dClient bin/balance
+	-mv src64/tags.orig src64/tags
 
 override_dh_compress:

## picolisp 3.0.9.1

=== debian/changelog ===
picolisp (3.0.9.1-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Add hardening-includes to build dependency.
  * debian/rules:
    - Enable hardening flags.
    - Install bash_completion.

 -- Kan-Ru Chen <koster@debian.org>  Mon, 02 Jan 2012 11:25:29 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: lisp
 Priority: optional
 Maintainer: Kan-Ru Chen <koster@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), libssl-dev, gcc-multilib [amd64]
+Build-Depends: debhelper (>= 7.0.50~), libssl-dev, hardening-includes, gcc-multilib [amd64]
 Standards-Version: 3.9.2
 Homepage: http://picolisp.com/
 Vcs-Git: git://git.debian.org/collab-maint/picolisp.git

=== debian/rules ===
--- 
+++ 
@@ -1,11 +1,20 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
-
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
-
 DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
 DEB_HOST_ARCH_OS  := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
+
+ifeq (amd64,$(DEB_HOST_ARCH_CPU))
+  # disabled on amd64
+  DEB_BUILD_HARDENING_PIE := 0
+endif
+
+include /usr/share/hardening-includes/hardening.make
+export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
+export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
+CFLAGS+=$(HARDENING_CFLAGS)
+LDFLAGS+=$(HARDENING_LDFLAGS)
 
 override_dh_auto_build:
 
@@ -18,9 +27,12 @@
 	mv src64/tags src64/tags.orig
 	make -C src64 OS=Linux
 endif
+	mkdir -p build/bash_completion.d
+	cp lib/bash_completion build/bash_completion.d/pil
 
 override_dh_auto_install:
 
+	dh_install build/bash_completion.d/pil etc/bash_completion.d
 	dh_install -X.o src   usr/lib/picolisp
 	dh_install -X.o src64 usr/lib/picolisp
 
@@ -30,6 +42,7 @@
 	make -C src64 clean
 	-rm bin/ssl bin/httpGate bin/lat1 bin/utf2 bin/z3dClient bin/balance
 	-mv src64/tags.orig src64/tags
+	-rm -rf build
 
 override_dh_compress:

## picolisp 3.0.9.4

=== debian/changelog ===
picolisp (3.0.9.4-1) unstable; urgency=low

  * New upstream release.
  * Sync to upstream tip.
  * debian/patches/picolisp_build_on_multi_cpu.patch:
    - Correctly append CFLAGS to upstream CFLAGS. Fixes FTBFS on armhf.
      Thanks to Peter Green and Hector Oron (Closes: #660324).
  * debian/copyright:
    - Update copyright-format to 1.0.
  * debian/control:
    - Bump Standards-Version to 3.9.3.

 -- Kan-Ru Chen <koster@debian.org>  Mon, 05 Mar 2012 22:41:16 +0800

picolisp (3.0.9.3-1) unstable; urgency=low

  * New upstream release.
  * Sync to upstream tip.

 -- Kan-Ru Chen <koster@debian.org>  Fri, 17 Feb 2012 23:07:13 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Kan-Ru Chen <koster@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), libssl-dev, hardening-includes, gcc-multilib [amd64]
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://picolisp.com/
 Vcs-Git: git://git.debian.org/collab-maint/picolisp.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/picolisp.git;a=summary

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,9 @@
 DEB_HOST_ARCH_OS  := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 
 ifeq (amd64,$(DEB_HOST_ARCH_CPU))
-  # disabled on amd64
+  # disabled on amd64 because it's mostly written in assembly and
+  # already handles PIC when needed. The codes aren't compiled with
+  # gcc so enable -fPIE is meaningless.
   DEB_BUILD_HARDENING_PIE := 0
 endif

## picolisp 3.1.0.7

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 07mar11abu
+# 07feb12abu
 # 27feb08rdo
 # (c) Software Lab. Alexander Burger
 
@@ -7,7 +7,7 @@
 
 picoFiles = main.c gc.c apply.c flow.c sym.c subr.c big.c io.c net.c tab.c
 
-CFLAGS := -c -O2 -m32 -pipe \
+CFLAGS = -c -O2 -m32 -pipe \
 	-falign-functions -fomit-frame-pointer -fno-strict-aliasing \
 	-W -Wimplicit -Wreturn-type -Wunused -Wformat \
 	-Wuninitialized -Wstrict-prototypes \

=== src64/Makefile ===
# 01nov11abu
# (c) Software Lab. Alexander Burger

.SILENT:

bin = ../bin
lib = ../lib

ifneq ($(filter x86-64.linux, $(MAKECMDGOALS)),)
	UNAME = Linux
	MACHINE = x86_64
else
	ifneq ($(filter x86-64.sunOs, $(MAKECMDGOALS)),)
		UNAME = SunOS
		MACHINE = x86_64
	else
      ifneq ($(filter ppc64.linux, $(MAKECMDGOALS)),)
         UNAME = Linux
         MACHINE = ppc64
      else
         UNAME = $(shell uname)
         MACHINE = $(shell uname -m)
      endif
	endif
endif

ifeq ($(UNAME), Linux)
	OS = Linux
	SYS = linux
	ifeq ($(MACHINE), x86_64)
		ARCH = x86-64
		MKASM-BASE =
		MKASM-LIB = -fpic
		AS = as
	else
	ifeq ($(MACHINE), ppc64)
		ARCH = ppc64
		MKASM-BASE = -'prSym "ppc64.symtab"'
		MKASM-LIB = -fpic -'rdSym "ppc64.symtab"'
		AS = as -mppc64 -a64
	endif
	endif
	LD-MAIN = -m64 -rdynamic -lc -lm -ldl
	LD-SHARED = -m64 -shared -export-dynamic
	STRIP = strip
else
ifeq ($(UNAME), SunOS)
	OS = SunOS
	SYS = sunOs
	ARCH = x86-64
	MKASM-BASE =
	MKASM-LIB = -fpic
	AS = gas --64
	LD-MAIN = -m64 -lc -lm -ldl -lsocket -lnsl
	LD-SHARED = -m64 -shared
	STRIP = strip
endif
endif

baseFiles = version.l glob.l main.l \
	gc.l apply.l flow.l sym.l subr.l big.l io.l db.l net.l err.l

sFiles = $(ARCH).$(SYS).base.s $(ARCH).$(SYS).ext.s $(ARCH).$(SYS).ht.s

all: picolisp

x86-64.linux: $(sFiles)
x86-64.sunOs: $(sFiles)
ppc64.linux: $(sFiles)

picolisp: $(bin)/picolisp $(lib)/ext $(lib)/ht

$(bin)/picolisp: $(ARCH).$(SYS).base.o
	mkdir -p $(bin) $(lib)
	gcc -o $(bin)/picolisp $(ARCH).$(SYS).base.o -Wl,--no-as-needed $(LD-MAIN)
	$(STRIP) $(bin)/picolisp

$(lib)/ext: $(ARCH).$(SYS).ext.o
	gcc -o $(lib)/ext $(ARCH).$(SYS).ext.o $(LD-SHARED)
	$(STRIP) $(lib)/ext

$(lib)/ht: $(ARCH).$(SYS).ht.o
	gcc -o $(lib)/ht $(ARCH).$(SYS).ht.o $(LD-SHARED)
	$(STRIP) $(lib)/ht

.s.o:
	$(AS) -o $*.o $*.s


# Explicit builds for cross-assembly
$(ARCH).$(SYS).base.s: lib/asm.l arch/$(ARCH).l $(baseFiles) sys/$(ARCH).$(SYS).code.l
	./mkAsm $(ARCH) $(SYS) $(OS) base $(lib)/map $(baseFiles) sys/$(ARCH).$(SYS).code.l $(MKASM-BASE)

$(ARCH).$(SYS).ext.s: lib/asm.l arch/$(ARCH).l ext.l $(ARCH).$(SYS).base.s
	./mkAsm $(ARCH) $(SYS) $(OS) ext "" $(MKASM-LIB) ext.l

$(ARCH).$(SYS).ht.s: lib/asm.l arch/$(ARCH).l ht.l $(ARCH).$(SYS).base.s
	./mkAsm $(ARCH) $(SYS) $(OS) ht "" $(MKASM-LIB) ht.l


# Clean up
clean:
	rm -f *.s *.o *.symtab

# vi:noet:ts=4:sw=4

=== debian/changelog ===
picolisp (3.1.0.7-1) unstable; urgency=low

  * New upstream release.
  * Sync to upstream tip.
  * debian/control:
    - Update Vcs-* url

 -- Kan-Ru Chen <koster@debian.org>  Mon, 25 Jun 2012 14:30:32 +0800

picolisp (3.1.0.4-1) unstable; urgency=low

  * New upstream release.
  * Sync to upstream tip.

 -- Kan-Ru Chen <koster@debian.org>  Wed, 02 May 2012 09:01:32 +0800

picolisp (3.0.9.7-1) unstable; urgency=low

  * New upstream release.
  * Sync to upstream tip.
  * Enable hardening flags on helper binaries. (Closes: #663355)
  * debian/control:
    - Build-Depends on lib32gcc1 for amd64 to workaround #667519

 -- Kan-Ru Chen <koster@debian.org>  Sun, 08 Apr 2012 21:31:01 +0800

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: lisp
 Priority: optional
 Maintainer: Kan-Ru Chen <koster@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), libssl-dev, hardening-includes, gcc-multilib [amd64]
+Build-Depends: debhelper (>= 7.0.50~), libssl-dev, hardening-includes, gcc-multilib [amd64], lib32gcc1 [amd64]
 Standards-Version: 3.9.3
 Homepage: http://picolisp.com/
-Vcs-Git: git://git.debian.org/collab-maint/picolisp.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/picolisp.git;a=summary
+Vcs-Git: git://anonscm.debian.org/collab-maint/picolisp.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/picolisp.git;a=summary
 
 # Only supports amd64 on linux and solaris
 Package: picolisp

=== debian/rules ===
--- 
+++ 
@@ -5,29 +5,35 @@
 DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
 DEB_HOST_ARCH_OS  := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 
-ifeq (amd64,$(DEB_HOST_ARCH_CPU))
-  # disabled on amd64 because it's mostly written in assembly and
-  # already handles PIC when needed. The codes aren't compiled with
-  # gcc so enable -fPIE is meaningless.
-  DEB_BUILD_HARDENING_PIE := 0
-endif
-
 include /usr/share/hardening-includes/hardening.make
 export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
 export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
-CFLAGS+=$(HARDENING_CFLAGS)
-LDFLAGS+=$(HARDENING_LDFLAGS)
+
+# PIE disabled on amd64 because it's mostly written in assembly and
+# already handles PIC when needed. The codes aren't compiled with
+# gcc so enable -fPIE is meaningless.
+CFLAGS_NO_PIE := $(CFLAGS) \
+                 $(filter-out $(HARDENING_DISABLE_PIE_CFLAGS_FILTER),$(HARDENING_CFLAGS))
+LDFLAGS_NO_PIE := $(LDFLAGS) \
+                  $(filter-out $(HARDENING_DISABLE_PIE_LDFLAGS_FILTER),$(HARDENING_LDFLAGS))
+
+CFLAGS += $(HARDENING_CFLAGS_PIC) \
+          $(filter-out $(HARDENING_DISABLE_PIE_CFLAGS_FILTER),$(HARDENING_CFLAGS))
+LDFLAGS += $(HARDENING_LDFLAGS) -Wl,-z,noexecstack
 
 override_dh_auto_build:
 
 	chmod -x app/loc/no
 	chmod +x bin/plmod
 
-	make -C src OS=Linux CPU=$(DEB_HOST_ARCH_CPU) picolisp tools gate
-
 ifeq (amd64,$(DEB_HOST_ARCH_CPU))
 	mv src64/tags src64/tags.orig
-	make -C src64 OS=Linux
+	make -C src OS=Linux CPU=amd64 picolisp
+	make -C src OS=Linux tools gate
+
+	make -C src64 OS=Linux CFLAGS="$(CFLAGS_NO_PIE)" LDFLAGS="$(LDFLAGS_NO_PIE)"
+else
+	make -C src OS=Linux CPU=$(DEB_HOST_ARCH_CPU) picolisp tools gate
 endif
 	mkdir -p build/bash_completion.d
 	cp lib/bash_completion build/bash_completion.d/pil
@@ -42,7 +48,7 @@
 
 	make -C src clean
 	make -C src64 clean
-	-rm bin/ssl bin/httpGate bin/lat1 bin/utf2 bin/z3dClient bin/balance
+	-rm bin/ssl bin/httpGate bin/lat1 bin/utf2 bin/balance
 	-mv src64/tags.orig src64/tags
 	-rm -rf build

## picolisp 3.1.1.1

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 07feb12abu
+# 05nov12abu
 # 27feb08rdo
 # (c) Software Lab. Alexander Burger
 
@@ -47,7 +47,7 @@
 	PICOLISP-FLAGS = -m32
 	LIB-FLAGS = -lc -lm -ldl
 	DYNAMIC-LIB-FLAGS = -m32 -dynamiclib -undefined dynamic_lookup
-	STRIP = :
+	STRIP = strip -x
 else
 ifeq ($(shell uname -o), Cygwin)
 	OS = Cygwin

=== src64/Makefile ===
# 05nov12abu
# (c) Software Lab. Alexander Burger

.SILENT:

bin = ../bin
lib = ../lib

ifeq ($(MAKECMDGOALS), x86-64.linux)
	UNAME = Linux
	MACHINE = x86_64
else
	ifeq ($(MAKECMDGOALS), x86-64.sunOs)
		UNAME = SunOS
		MACHINE = x86_64
	else
		ifeq ($(MAKECMDGOALS), ppc64.linux)
			UNAME = Linux
			MACHINE = ppc64
		else
			UNAME = $(shell uname)
			ifeq ($(MAKECMDGOALS), emu)
				MACHINE = emu
			else
				MACHINE = $(shell uname -m)
			endif
		endif
	endif
endif

SYS =
FMT = .c
ARCH = emu
STRIP = :

ifeq ($(UNAME), Linux)
	OS = Linux
	ifeq ($(MACHINE), x86_64)
		SYS = .linux
		FMT = .s
		ARCH = x86-64
		AS = as
	else
		ifeq ($(MACHINE), ppc64)
			SYS = .linux
			FMT = .s
			ARCH = ppc64
			AS = as -mppc64 -a64
		endif
	endif
	LD-MAIN = -Wl,--no-as-needed -rdynamic -lc -lm -ldl
	LD-SHARED = -shared -export-dynamic
	STRIP = strip
else
	ifeq ($(UNAME), SunOS)
		OS = SunOS
		SYS = .sunOs
		FMT = .s
		ARCH = x86-64
		AS = gas --64
		LD-MAIN = -m64 -lc -lm -ldl -lsocket -lnsl
		LD-SHARED = -m64 -shared
		STRIP = strip
	else
		ifeq ($(UNAME), Darwin)
			OS = Darwin
			LD-MAIN = -lc -lm -ldl
			LD-SHARED = -dynamiclib -undefined dynamic_lookup
			STRIP = strip -x
		endif
	endif
endif

baseFiles = version.l glob.l main.l \
	gc.l apply.l flow.l sym.l subr.l big.l io.l db.l net.l err.l

sFiles = \
	$(ARCH)$(SYS).base$(FMT) \
	$(ARCH)$(SYS).ext$(FMT) \
	$(ARCH)$(SYS).ht$(FMT)

all: picolisp

x86-64.linux: $(sFiles)
x86-64.sunOs: $(sFiles)
ppc64.linux: $(sFiles)
emu: picolisp

picolisp: $(bin)/picolisp $(lib)/ext $(lib)/ht

### Link ###
$(bin)/picolisp: $(ARCH)$(SYS).base.o
	$(CC) -o $(bin)/picolisp $(ARCH)$(SYS).base.o $(LD-MAIN)
	$(STRIP) $(bin)/picolisp

$(lib)/ext: $(ARCH)$(SYS).ext.o
	$(CC) -o $(lib)/ext $(ARCH)$(SYS).ext.o $(LD-SHARED)
	$(STRIP) $(lib)/ext

$(lib)/ht: $(ARCH)$(SYS).ht.o
	$(CC) -o $(lib)/ht $(ARCH)$(SYS).ht.o $(LD-SHARED)
	$(STRIP) $(lib)/ht

### Assemble ###
.s.o:
	$(AS) -o $*.o $*.s

### Compile ###
sysdefs: sysdefs.c
	$(CC) -o sysdefs -D_FILE_OFFSET_BITS=64 sysdefs.c
	$(STRIP) sysdefs

emu.base.o: emu.base.c
	$(CC) -c -O -fomit-frame-pointer -D_FILE_OFFSET_BITS=64 emu.base.c

.c.o:
	$(CC) -c -O -fpic -fomit-frame-pointer -D_FILE_OFFSET_BITS=64 $*.c

### Translate ###
$(ARCH)$(SYS).base$(FMT): sysdefs arch/$(ARCH).l $(baseFiles) sys/$(ARCH)$(SYS).code.l
	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) base "" $(lib)/map  $(baseFiles) sys/$(ARCH)$(SYS).code.l

$(ARCH)$(SYS).ext$(FMT): sysdefs arch/$(ARCH).l ext.l $(ARCH)$(SYS).base$(FMT)
	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) ext T ""  ext.l

$(ARCH)$(SYS).ht$(FMT): sysdefs arch/$(ARCH).l ht.l $(ARCH)$(SYS).base$(FMT)
	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) ht T ""  ht.l

### Clean up ###
clean:
	rm -f emu.*.c *.s *.o *.symtab sysdefs

# vi:noet:ts=4:sw=4

=== debian/changelog ===
picolisp (3.1.1.1-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright:
    - Update copyright for new files.
  * debian/rules:
    - Include `dpkg-buildflags --get CPPFLAGS'.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 06 Dec 2012 10:22:21 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: picolisp
 Section: lisp
 Priority: optional
-Maintainer: Kan-Ru Chen <koster@debian.org>
+Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), libssl-dev, hardening-includes, gcc-multilib [amd64], lib32gcc1 [amd64]
 Standards-Version: 3.9.3
 Homepage: http://picolisp.com/

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,7 @@
 DEB_HOST_ARCH_OS  := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 
 include /usr/share/hardening-includes/hardening.make
+export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
 export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
 export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
 
@@ -18,7 +19,9 @@
                   $(filter-out $(HARDENING_DISABLE_PIE_LDFLAGS_FILTER),$(HARDENING_LDFLAGS))
 
 CFLAGS += $(HARDENING_CFLAGS_PIC) \
-          $(filter-out $(HARDENING_DISABLE_PIE_CFLAGS_FILTER),$(HARDENING_CFLAGS))
+          $(filter-out $(HARDENING_DISABLE_PIE_CFLAGS_FILTER),$(HARDENING_CFLAGS)) \
+          $(HARDENING_CPPFLAGS) \
+          $(NULL)
 LDFLAGS += $(HARDENING_LDFLAGS) -Wl,-z,noexecstack
 
 override_dh_auto_build:
@@ -37,6 +40,9 @@
 endif
 	mkdir -p build/bash_completion.d
 	cp lib/bash_completion build/bash_completion.d/pil
+
+#       build time utilities
+	-rm src64/sysdeps
 
 override_dh_auto_install:

## picolisp 3.1.2.12

=== debian/changelog ===
picolisp (3.1.2.12-1) unstable; urgency=low

  * New upstream release.
  * Refresh patches.
  * debian/control:
    - Bump Standards-Version to 3.9.4.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 20 Jun 2013 21:52:27 +0800

picolisp (3.1.1.15-1) unstable; urgency=low

  * New upstream release.
  * Sync to upstream tip.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 06 Mar 2013 00:21:35 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), libssl-dev, hardening-includes, gcc-multilib [amd64], lib32gcc1 [amd64]
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://picolisp.com/
 Vcs-Git: git://anonscm.debian.org/collab-maint/picolisp.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/picolisp.git;a=summary

=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,6 @@
 override_dh_auto_build:
 
 	chmod -x app/loc/no
-	chmod +x bin/plmod
 
 ifeq (amd64,$(DEB_HOST_ARCH_CPU))
 	mv src64/tags src64/tags.orig

## picolisp 3.1.5.2

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 05nov12abu
+# 02jun13abu
 # 27feb08rdo
 # (c) Software Lab. Alexander Burger
 
@@ -19,6 +19,7 @@
 	PICOLISP-FLAGS = -m32 -rdynamic
 	LIB-FLAGS = -lc -lm -ldl
 	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
+	LCRYPT = -lcrypt
 	STRIP = strip
 else
 ifeq ($(shell uname), OpenBSD)
@@ -26,6 +27,7 @@
 	PICOLISP-FLAGS = -m32 -rdynamic -Wl,-E
 	LIB-FLAGS = -lc -lm
 	DYNAMIC-LIB-FLAGS = -Wl,-E -Wl,-shared
+	LCRYPT = -lcrypto
 	STRIP = strip
 else
 ifeq ($(shell uname), FreeBSD)
@@ -33,6 +35,7 @@
 	PICOLISP-FLAGS = -m32 -rdynamic
 	LIB-FLAGS = -lc -lm
 	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
+	LCRYPT = -lcrypto
 	STRIP = strip
 else
 ifeq ($(shell uname), NetBSD)
@@ -40,6 +43,7 @@
 	PICOLISP-FLAGS = -m32 -rdynamic
 	LIB-FLAGS = -lc -lm
 	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
+	LCRYPT = -lcrypto
 	STRIP = strip
 else
 ifeq ($(shell uname), Darwin)
@@ -47,6 +51,7 @@
 	PICOLISP-FLAGS = -m32
 	LIB-FLAGS = -lc -lm -ldl
 	DYNAMIC-LIB-FLAGS = -m32 -dynamiclib -undefined dynamic_lookup
+	LCRYPT = -lcrypto
 	STRIP = strip -x
 else
 ifeq ($(shell uname -o), Cygwin)
@@ -54,6 +59,7 @@
 	DYNAMIC-LIB-FLAGS = -shared
 	PICOLISP-FLAGS =
 	DLL-DEFS = $(bin)/picolisp.dll
+	LCRYPT = -lcrypt
 	STRIP = strip
 	exe = .exe
 	dll = .dll
@@ -65,18 +71,17 @@
 endif
 
 
-picolisp: $(bin)/picolisp $(lib)/ext$(dll) $(lib)/ht$(dll) $(lib)/z3d$(dll)
+picolisp: $(bin)/picolisp $(lib)/ext$(dll) $(lib)/ht$(dll)
 tools: $(bin)/lat1 $(bin)/utf2 $(bin)/balance
 gate: $(bin)/ssl $(bin)/httpGate
-x11: $(bin)/z3dClient
 
-all: picolisp tools gate x11
+all: picolisp tools gate
 
 .c.o:
 	gcc $(CFLAGS) -D_OS='"$(OS)"' $*.c
 
 
-$(picoFiles:.c=.o) ext.o ht.o z3d.o: pico.h
+$(picoFiles:.c=.o) ext.o ht.o: pico.h
 main.o: vers.h
 
 
@@ -102,16 +107,12 @@
 
 
 $(lib)/ext$(dll): ext.o
-	gcc -o $(lib)/ext$(dll) $(DYNAMIC-LIB-FLAGS) ext.o $(DLL-DEFS)
+	gcc -o $(lib)/ext$(dll) $(DYNAMIC-LIB-FLAGS) ext.o $(DLL-DEFS) $(LCRYPT)
 	$(STRIP) $(lib)/ext$(dll)
 
 $(lib)/ht$(dll): ht.o
 	gcc -o $(lib)/ht$(dll) $(DYNAMIC-LIB-FLAGS) ht.o $(DLL-DEFS)
 	$(STRIP) $(lib)/ht$(dll)
-
-$(lib)/z3d$(dll): z3d.o
-	gcc -o $(lib)/z3d$(dll)  $(DYNAMIC-LIB-FLAGS) z3d.o $(DLL-DEFS)
-	$(STRIP) $(lib)/z3d$(dll)
 
 
 $(bin)/lat1: lat1.c
@@ -134,10 +135,6 @@
 	gcc -o $(bin)/httpGate$(exe) httpGate.c -lssl -lcrypto
 	$(STRIP) $(bin)/httpGate$(exe)
 
-$(bin)/z3dClient: z3dClient.c
-	gcc -o $(bin)/z3dClient$(exe) z3dClient.c  -L/usr/X11R6/lib -lXext -lX11
-	$(STRIP) $(bin)/z3dClient$(exe)
-
 
 # Clean up
 clean:

=== src64/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 05nov12abu
+# 08jan13abu
 # (c) Software Lab. Alexander Burger
 
 .SILENT:
@@ -10,19 +10,24 @@
 	UNAME = Linux
 	MACHINE = x86_64
 else
-	ifeq ($(MAKECMDGOALS), x86-64.sunOs)
-		UNAME = SunOS
+	ifeq ($(MAKECMDGOALS), x86-64.freeBsd)
+		UNAME = FreeBSD
 		MACHINE = x86_64
 	else
-		ifeq ($(MAKECMDGOALS), ppc64.linux)
-			UNAME = Linux
-			MACHINE = ppc64
+		ifeq ($(MAKECMDGOALS), x86-64.sunOs)
+			UNAME = SunOS
+			MACHINE = x86_64
 		else
-			UNAME = $(shell uname)
-			ifeq ($(MAKECMDGOALS), emu)
-				MACHINE = emu
+			ifeq ($(MAKECMDGOALS), ppc64.linux)
+				UNAME = Linux
+				MACHINE = ppc64
 			else
-				MACHINE = $(shell uname -m)
+				UNAME = $(shell uname)
+				ifeq ($(MAKECMDGOALS), emu)
+					MACHINE = emu
+				else
+					MACHINE = $(shell uname -m)
+				endif
 			endif
 		endif
 	endif
@@ -52,21 +57,32 @@
 	LD-SHARED = -shared -export-dynamic
 	STRIP = strip
 else
-	ifeq ($(UNAME), SunOS)
-		OS = SunOS
-		SYS = .sunOs
+	ifeq ($(UNAME), FreeBSD)
+		OS = FreeBSD
+		SYS = .freeBsd
 		FMT = .s
 		ARCH = x86-64
-		AS = gas --64
-		LD-MAIN = -m64 -lc -lm -ldl -lsocket -lnsl
-		LD-SHARED = -m64 -shared
+		AS = as
+		LD-MAIN = -Wl,--no-as-needed -rdynamic -lc -lm
+		LD-SHARED = -shared -rdynamic
 		STRIP = strip
 	else
-		ifeq ($(UNAME), Darwin)
-			OS = Darwin
-			LD-MAIN = -lc -lm -ldl
-			LD-SHARED = -dynamiclib -undefined dynamic_lookup
-			STRIP = strip -x
+		ifeq ($(UNAME), SunOS)
+			OS = SunOS
+			SYS = .sunOs
+			FMT = .s
+			ARCH = x86-64
+			AS = gas --64
+			LD-MAIN = -m64 -lc -lm -ldl -lsocket -lnsl
+			LD-SHARED = -m64 -shared
+			STRIP = strip
+		else
+			ifeq ($(UNAME), Darwin)
+				OS = Darwin
+				LD-MAIN = -lc -lm -ldl
+				LD-SHARED = -dynamiclib -undefined dynamic_lookup
+				STRIP = strip -x
+			endif
 		endif
 	endif
 endif
@@ -82,6 +98,7 @@
 all: picolisp
 
 x86-64.linux: $(sFiles)
+x86-64.freeBsd: $(sFiles)
 x86-64.sunOs: $(sFiles)
 ppc64.linux: $(sFiles)
 emu: picolisp
@@ -110,20 +127,20 @@
 	$(CC) -o sysdefs -D_FILE_OFFSET_BITS=64 sysdefs.c
 	$(STRIP) sysdefs
 
-emu.base.o: emu.base.c
+emu.base.o: sysdefs emu.base.c
 	$(CC) -c -O -fomit-frame-pointer -D_FILE_OFFSET_BITS=64 emu.base.c
 
 .c.o:
 	$(CC) -c -O -fpic -fomit-frame-pointer -D_FILE_OFFSET_BITS=64 $*.c
 
 ### Translate ###
-$(ARCH)$(SYS).base$(FMT): sysdefs arch/$(ARCH).l $(baseFiles) sys/$(ARCH)$(SYS).code.l
+$(ARCH)$(SYS).base$(FMT): arch/$(ARCH).l $(baseFiles) sys/$(ARCH)$(SYS).code.l
 	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) base "" $(lib)/map  $(baseFiles) sys/$(ARCH)$(SYS).code.l
 
-$(ARCH)$(SYS).ext$(FMT): sysdefs arch/$(ARCH).l ext.l $(ARCH)$(SYS).base$(FMT)
+$(ARCH)$(SYS).ext$(FMT): arch/$(ARCH).l ext.l $(ARCH)$(SYS).base$(FMT)
 	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) ext T ""  ext.l
 
-$(ARCH)$(SYS).ht$(FMT): sysdefs arch/$(ARCH).l ht.l $(ARCH)$(SYS).base$(FMT)
+$(ARCH)$(SYS).ht$(FMT): arch/$(ARCH).l ht.l $(ARCH)$(SYS).base$(FMT)
 	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) ht T ""  ht.l
 
 ### Clean up ###

=== debian/changelog ===
picolisp (3.1.5.2-2) unstable; urgency=medium

  * Sync to tip.
  * debian/picolisp.install:
    - Include lib/phone.css
    - Install arch-indep files under /usr/share/picolisp
  * debian/source/lintian-overrides:
    - Override unknown architectures armel and armhf.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 15 Jan 2014 22:59:02 +0800

picolisp (3.1.5.2-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * debian/control:
    - Bump Standards-Version to 3.9.5.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 15 Jan 2014 00:41:33 +0800

picolisp (3.1.4.9-1) unstable; urgency=low

  * New upstream release.
  * Refresh patches.
  * debian/rules:
    - Checkout specific release tag directly.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 31 Oct 2013 18:19:34 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), libssl-dev, hardening-includes, gcc-multilib [amd64], lib32gcc1 [amd64]
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://picolisp.com/
 Vcs-Git: git://anonscm.debian.org/collab-maint/picolisp.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/picolisp.git;a=summary
@@ -11,6 +11,7 @@
 # Only supports amd64 on linux and solaris
 Package: picolisp
 Architecture: kopensolaris-amd64 solaris-amd64 amd64 any-i386 any-armel any-armeb any-arm any-avr32 any-hppa any-m32r any-m68k any-mips any-mipsel any-powerpc any-s390 any-sh3 any-sh3eb any-sh4 any-sh4eb any-sparc any-armhf
+Pre-Depends: dpkg (>= 1.17.5)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Lisp interpreter and application server framework
  Pico Lisp can be viewed from two different aspects: As a general

=== debian/rules ===
--- 
+++ 
@@ -46,8 +46,8 @@
 override_dh_auto_install:
 
 	dh_install build/bash_completion.d/pil etc/bash_completion.d
-	dh_install -X.o src   usr/lib/picolisp
-	dh_install -X.o src64 usr/lib/picolisp
+	dh_install -X.o src   usr/share/picolisp
+	dh_install -X.o src64 usr/share/picolisp
 
 override_dh_auto_clean:
 
@@ -67,8 +67,7 @@
 VER?=3.0.7.1
 get-orig-source:
 	rm -rf picolisp-$(VER).orig
-	hg clone https://picolisp.googlecode.com/hg/ picolisp-$(VER).orig
-	cd picolisp-$(VER).orig && hg up -r v$(VER)
+	hg clone https://picolisp.googlecode.com/hg/#v$(VER) picolisp-$(VER).orig
 	rm -r picolisp-$(VER).orig/.hg picolisp-$(VER).orig/.hgtags
 	GZIP=--best tar -cz --owner root --group root --mode a+rX \
 			-f picolisp_$(VER).orig.tar.gz \

## picolisp 3.1.7.3

=== debian/changelog ===
picolisp (3.1.7.3-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Use dpkg-buildflags instead of hardening-includes.
  * Do not use invalid architecture wildcards any-armel and
    any-armhf. (Closes: #749119)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 17 Jul 2014 23:40:45 +0800

picolisp (3.1.6.1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * debian/control:
    - Suggests tinymice.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 31 Mar 2014 00:06:09 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: lisp
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), libssl-dev, hardening-includes, gcc-multilib [amd64], lib32gcc1 [amd64]
+Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1~), libssl-dev, gcc-multilib [amd64], lib32gcc1 [amd64]
 Standards-Version: 3.9.5
 Homepage: http://picolisp.com/
 Vcs-Git: git://anonscm.debian.org/collab-maint/picolisp.git
@@ -10,9 +10,10 @@
 
 # Only supports amd64 on linux and solaris
 Package: picolisp
-Architecture: kopensolaris-amd64 solaris-amd64 amd64 any-i386 any-armel any-armeb any-arm any-avr32 any-hppa any-m32r any-m68k any-mips any-mipsel any-powerpc any-s390 any-sh3 any-sh3eb any-sh4 any-sh4eb any-sparc any-armhf
+Architecture: kopensolaris-amd64 solaris-amd64 amd64 any-i386 any-arm any-avr32 any-hppa any-m32r any-m68k any-mips any-mipsel any-powerpc any-s390 any-sh3 any-sh3eb any-sh4 any-sh4eb any-sparc
 Pre-Depends: dpkg (>= 1.17.5)
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Suggests: tinymice
 Description: Lisp interpreter and application server framework
  Pico Lisp can be viewed from two different aspects: As a general
  purpose programming language, and a dedicated application server

=== debian/rules ===
--- 
+++ 
@@ -5,24 +5,20 @@
 DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
 DEB_HOST_ARCH_OS  := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 
-include /usr/share/hardening-includes/hardening.make
-export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
-export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
-export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
 
+ifeq (amd64,$(DEB_HOST_ARCH_CPU))
 # PIE disabled on amd64 because it's mostly written in assembly and
 # already handles PIC when needed. The codes aren't compiled with
 # gcc so enable -fPIE is meaningless.
-CFLAGS_NO_PIE := $(CFLAGS) \
-                 $(filter-out $(HARDENING_DISABLE_PIE_CFLAGS_FILTER),$(HARDENING_CFLAGS))
-LDFLAGS_NO_PIE := $(LDFLAGS) \
-                  $(filter-out $(HARDENING_DISABLE_PIE_LDFLAGS_FILTER),$(HARDENING_LDFLAGS))
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
+CFLAGS_NO_PIE := $(shell dpkg-buildflags --get CFLAGS)
+LDFLAGS_NO_PIE := $(shell dpkg-buildflags --get LDFLAGS)
+endif
 
-CFLAGS += $(HARDENING_CFLAGS_PIC) \
-          $(filter-out $(HARDENING_DISABLE_PIE_CFLAGS_FILTER),$(HARDENING_CFLAGS)) \
-          $(HARDENING_CPPFLAGS) \
-          $(NULL)
-LDFLAGS += $(HARDENING_LDFLAGS) -Wl,-z,noexecstack
+LDFLAGS += -Wl,-z,noexecstack
 
 override_dh_auto_build:

## picolisp 3.1.8.0

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 02jun13abu
+# 14sep14abu
 # 27feb08rdo
 # (c) Software Lab. Alexander Burger
 
@@ -7,8 +7,8 @@
 
 picoFiles = main.c gc.c apply.c flow.c sym.c subr.c big.c io.c net.c tab.c
 
-CFLAGS = -c -O2 -m32 -pipe \
-	-falign-functions -fomit-frame-pointer -fno-strict-aliasing \
+CFLAGS = -c -O2 -pipe \
+	-falign-functions=32 -fomit-frame-pointer -fno-strict-aliasing \
 	-W -Wimplicit -Wreturn-type -Wunused -Wformat \
 	-Wuninitialized -Wstrict-prototypes \
 	-D_GNU_SOURCE  -D_FILE_OFFSET_BITS=64
@@ -16,46 +16,70 @@
 
 ifeq ($(shell uname), Linux)
 	OS = Linux
+	CFLAGS += -m32
 	PICOLISP-FLAGS = -m32 -rdynamic
-	LIB-FLAGS = -lc -lm -ldl
+	LIB-FLAGS = -lm -ldl
 	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
 	LCRYPT = -lcrypt
 	STRIP = strip
 else
 ifeq ($(shell uname), OpenBSD)
 	OS = OpenBSD
+	CFLAGS += -m32
 	PICOLISP-FLAGS = -m32 -rdynamic -Wl,-E
-	LIB-FLAGS = -lc -lm
+	LIB-FLAGS = -lm
 	DYNAMIC-LIB-FLAGS = -Wl,-E -Wl,-shared
 	LCRYPT = -lcrypto
 	STRIP = strip
 else
 ifeq ($(shell uname), FreeBSD)
 	OS = FreeBSD
+	CFLAGS += -m32
 	PICOLISP-FLAGS = -m32 -rdynamic
-	LIB-FLAGS = -lc -lm
+	LIB-FLAGS = -lm
 	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
-	LCRYPT = -lcrypto
+	LCRYPT = -lcrypt
 	STRIP = strip
 else
 ifeq ($(shell uname), NetBSD)
 	OS = NetBSD
+	CFLAGS += -m32
 	PICOLISP-FLAGS = -m32 -rdynamic
-	LIB-FLAGS = -lc -lm
+	LIB-FLAGS = -lm
 	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
 	LCRYPT = -lcrypto
 	STRIP = strip
 else
 ifeq ($(shell uname), Darwin)
 	OS = Darwin
+	CFLAGS += -m32
 	PICOLISP-FLAGS = -m32
 	LIB-FLAGS = -lc -lm -ldl
 	DYNAMIC-LIB-FLAGS = -m32 -dynamiclib -undefined dynamic_lookup
 	LCRYPT = -lcrypto
 	STRIP = strip -x
 else
+ifeq ($(shell uname), SunOS)
+	OS = SunOS
+	CFLAGS += -m32
+	PICOLISP-FLAGS =
+	LIB-FLAGS = -lm -lnsl -lsocket
+	DYNAMIC-LIB-FLAGS = -G
+	LCRYPT = -lcrypt
+	STRIP = strip
+else
+ifeq ($(shell uname), AIX)
+	OS = AIX
+	CFLAGS += -maix32
+	PICOLISP-FLAGS = -maix32 -Wl,-brtl -Wl,-bexpall
+	LIB-FLAGS = -lm
+	DYNAMIC-LIB-FLAGS = -maix32 -Wl,-G -shared -lm
+	LCRYPT = -lcrypt
+	STRIP = strip
+else
 ifeq ($(shell uname -o), Cygwin)
 	OS = Cygwin
+	CFLAGS += -m32
 	DYNAMIC-LIB-FLAGS = -shared
 	PICOLISP-FLAGS =
 	DLL-DEFS = $(bin)/picolisp.dll
@@ -63,6 +87,8 @@
 	STRIP = strip
 	exe = .exe
 	dll = .dll
+endif
+endif
 endif
 endif
 endif

=== src64/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 08jan13abu
+# 21may14abu
 # (c) Software Lab. Alexander Burger
 
 .SILENT:
@@ -134,13 +134,13 @@
 	$(CC) -c -O -fpic -fomit-frame-pointer -D_FILE_OFFSET_BITS=64 $*.c
 
 ### Translate ###
-$(ARCH)$(SYS).base$(FMT): arch/$(ARCH).l $(baseFiles) sys/$(ARCH)$(SYS).code.l
+$(ARCH)$(SYS).base$(FMT): arch/$(ARCH).l defs.l $(baseFiles) sys/$(ARCH)$(SYS).code.l
 	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) base "" $(lib)/map  $(baseFiles) sys/$(ARCH)$(SYS).code.l
 
-$(ARCH)$(SYS).ext$(FMT): arch/$(ARCH).l ext.l $(ARCH)$(SYS).base$(FMT)
+$(ARCH)$(SYS).ext$(FMT): arch/$(ARCH).l defs.l ext.l $(ARCH)$(SYS).base$(FMT)
 	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) ext T ""  ext.l
 
-$(ARCH)$(SYS).ht$(FMT): arch/$(ARCH).l ht.l $(ARCH)$(SYS).base$(FMT)
+$(ARCH)$(SYS).ht$(FMT): arch/$(ARCH).l defs.l ht.l $(ARCH)$(SYS).base$(FMT)
 	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) ht T ""  ht.l
 
 ### Clean up ###

=== debian/changelog ===
picolisp (3.1.8.0-4) unstable; urgency=medium

  * Really fix FTBFS on armhf

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Fri, 03 Oct 2014 02:21:16 +0800

picolisp (3.1.8.0-3) unstable; urgency=medium

  * Force ARM mode to fix FTBFS on armhf (Closes: #763764)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Fri, 03 Oct 2014 01:22:26 +0800

picolisp (3.1.8.0-2) unstable; urgency=medium

  * Use build directory as HOME when running test, fix FTBFS (Closes: #763663)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 02 Oct 2014 09:38:34 +0800

picolisp (3.1.8.0-1) unstable; urgency=medium

  * Imported Upstream version 3.1.8.0
  * Refresh patches
  * Fix typo in Suggests: tinymce (Closes: #762507)
  * Run tests after build
  * Fix lintian warning empty-short-license-in-dep5-copyright
  * Bump Standards-Version to 3.9.6, no changes needed

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 01 Oct 2014 23:37:52 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1~), libssl-dev, gcc-multilib [amd64], lib32gcc1 [amd64]
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://picolisp.com/
 Vcs-Git: git://anonscm.debian.org/collab-maint/picolisp.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/picolisp.git;a=summary
@@ -13,7 +13,7 @@
 Architecture: kopensolaris-amd64 solaris-amd64 amd64 any-i386 any-arm any-avr32 any-hppa any-m32r any-m68k any-mips any-mipsel any-powerpc any-s390 any-sh3 any-sh3eb any-sh4 any-sh4eb any-sparc
 Pre-Depends: dpkg (>= 1.17.5)
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: tinymice
+Suggests: tinymce
 Description: Lisp interpreter and application server framework
  Pico Lisp can be viewed from two different aspects: As a general
  purpose programming language, and a dedicated application server

=== debian/rules ===
--- 
+++ 
@@ -20,6 +20,10 @@
 
 LDFLAGS += -Wl,-z,noexecstack
 
+ifeq (arm,$(DEB_HOST_ARCH_CPU))
+CFLAGS += -marm
+endif
+
 override_dh_auto_build:
 
 	chmod -x app/loc/no
@@ -38,6 +42,9 @@
 
 #       build time utilities
 	-rm src64/sysdeps
+
+override_dh_auto_test:
+	HOME=$(CURDIR)/build $(CURDIR)/pil test/lib.l -bye + < /dev/null
 
 override_dh_auto_install:

=== debian/watch ===
version=3

http://software-lab.de/down.html picoLisp-(.*)\.tgz
